package printertest.nowyouseeme.net.kotlinprinter

import android.graphics.Bitmap
import android.graphics.BitmapFactory
import android.support.v7.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Toast
import android_serialport_api.Printer
import android_serialport_api.Printer.DataListener
import android_serialport_api.PowerControl
import com.github.kittinunf.fuel.Fuel
import com.github.kittinunf.fuel.core.FuelError
import kotlinx.android.synthetic.main.activity_main.*
import java.io.IOException
import org.jetbrains.anko.*
import com.github.kittinunf.result.getAs
import com.github.kittinunf.fuel.core.deserializers.StringDeserializer
import com.github.kittinunf.result.Result
import com.github.kittinunf.fuel.httpGet
import org.jetbrains.anko.appcompat.v7.alertDialogLayout
import java.net.URI


class MainActivity : AppCompatActivity() {

    private var printer: Printer? = null
    private var bitmap: Bitmap? = null
    private var power: PowerControl? = null


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)
        printer = Printer(this)
        bitmap = BitmapFactory.decodeResource(resources,R.drawable.ic_visanet_dom)

        Log.i("Printer", "Printer init")
        initListener()
        Toast.makeText(this, "Printer init", Toast.LENGTH_LONG).show()

        val openPrinter: Int = printer!!.openPrinter()
        val URL: String = "http://apps.nowyouseeme.net/apk/net.nowyouseeme.pos.info"


        button_open.setOnClickListener{
            check_power()
            val openPrinter: Int = printer!!.openPrinter()/*
            alert("Esta es una prueb","ALERT") {
                yesButton { longToast("YES button") }
                noButton { longToast("NO button ") }
            }.show()

            val paises = listOf("uno","dos","tres")
            selector("dime algo",paises,{dialogInterface,i -> longToast("bien ${paises[i]},cierto?")})
            */
            //toast((R.string.main_data)
            //val dialog = progressDialog(message = "POPOLA.................", title = "ALERT").show()



        }

        button_print.setOnClickListener{
            try {
                //check_power()
                val bold: Int = printer!!.setBold(5)
                val left: Int = printer!!.setAlignType(2)
                val dataPrint = editText_result!!.text.toString()
                val openPrinter = printer!!.printString(dataPrint)
                Toast.makeText(this, "$bold $left $openPrinter", Toast.LENGTH_SHORT).show()
                editText_result.text = null
            }catch(e: IOException){
                Toast.makeText(this,e.toString(),Toast.LENGTH_LONG).show()
                return@setOnClickListener
            }
        }

        button_close.setOnClickListener{
            check_power()
            val closePrinter: Int = printer!!.closePrinter()
        }

        button_picture.setOnClickListener{
            //check_power()
            longToast("Picture")
            //val printImage: Int = printer!!.PrintPicture(bitmap)  //.printPicture(bitmap)
            val printer2: Int =printer!!.printEAN13("Esta es una prueba")
        }

        button_printLF.setOnClickListener{
            val linefeed: Int = printer!!.printLF(10)
        }

        button_Login.setOnClickListener(){
            //startActivity()
        }

    }

    private fun initListener() {
        printer!!.setDataListener(DataListener { data ->
            Toast.makeText(this@MainActivity, data.toString(), Toast.LENGTH_SHORT).show()
            //textView.setText(new BigInteger(1,data).toString(16).trim());
            //textView.text = data.toString()
        })
    }

    private fun check_power(){
        Toast.makeText(this, power.toString(),Toast.LENGTH_SHORT).show()

    }



    private fun <T : Any> update(result: Result<T, FuelError>) {
        result.fold(success = {
            toast(it.toString())
        }, failure = {
            toast(String(it.errorData))
        })


    }

}
